#include <stdio.h>
#include <stdlib.h>
#include <alloca.h>

// ссылочные структуры:
#define SIZE 7

//---------------------------------------------------------

typedef struct node_single {
   struct node_single *next;
   int data;  // данные узла
} node_single_t;

node_single_t* single_add_after( node_single_t *new, node_single_t *node ) {
   new->next = node->next;
   node->next = new;
   return new;
}

void test020( void ) {
   struct node_single nd = { NULL, 1 }, *head = &nd, *pc = head;
   int i;
   for( i = 0; i < SIZE; i ++ )
      ( pc = single_add_after( 
                (node_single_t*)alloca( sizeof( node_single_t) ), pc 
                             )
      )->data = i + 2;
   pc = head;
   do {                        // печать элементов списка
      printf( "%d, ", pc->data );
      pc = pc->next;
   } while( pc != NULL );
   printf( "\n" ); 
}

//---------------------------------------------------------
// from kernel: "/lib/modules/.../source/include/linux/list.h"
typedef struct list_head {
   struct list_head *next, *prev;
} list_head_t;

void INIT_LIST_HEAD( list_head_t *list ) {
   list->next = list;
   list->prev = list;
}

list_head_t* list_add_after( list_head_t *new, list_head_t *node ) {
   node->next->prev = new;
   new->next = node->next;
   new->prev = node;
   node->next = new;
   return new;
}

typedef struct node {
   list_head_t link;
   int data;  // данные узла
} node_t;

void test030( void ) {
   node_t nd = { {}, 1 }, *head = &nd;
   INIT_LIST_HEAD( &head->link );
   int i;
   list_head_t *lhead = &head->link, *pc = lhead;
   for( i = 0; i < SIZE; i ++ )
      ((struct node*)( pc = list_add_after(
                         (list_head_t*)alloca( sizeof( node_t ) ), pc 
                                          )
                     ))->data = i + 2;
   pc = lhead;   
   do {                        // обход кольцевого списка вперёд
      printf( "%d, ", ((struct node*)pc)->data );
      pc = pc->next;
   } while( pc != lhead );
   pc = pc->prev;
   do {                        // обход кольцевого списка назад
      printf( "%d, ", ((struct node*)(pc->prev))->data );
      pc = pc->prev;
   } while( pc != lhead );
   printf( "\n" ); 
}

//---------------------------------------------------------

void ( *tests[] )( void ) = {          // последовательность тестов
        test020,                       // 1-но связный список
        test030,                       // 2-х связный кольцевой список
};
#include "main.c"

